"use strict";

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

const path = require('path');

const _require = require('unist-util-select'),
      selectAll = _require.selectAll;

const parse5 = require('parse5');

const sharp = require(`gatsby-plugin-sharp`);

module.exports =
/*#__PURE__*/
function () {
  var _ref = _asyncToGenerator(function* ({
    markdownAST: mdast,
    markdownNode,
    files,
    getNode,
    reporter,
    cache,
    pathPrefix
  }, pluginOptions) {
    const plugins = pluginOptions.plugins,
          _pluginOptions$compon = pluginOptions.componentName,
          componentName = _pluginOptions$compon === void 0 ? 'image-wrapper' : _pluginOptions$compon,
          _pluginOptions$imageP = pluginOptions.imagePropName,
          imagePropName = _pluginOptions$imageP === void 0 ? 'src' : _pluginOptions$imageP,
          _pluginOptions$sharpM = pluginOptions.sharpMethod,
          sharpMethod = _pluginOptions$sharpM === void 0 ? 'fluid' : _pluginOptions$sharpM,
          imageOptions = _objectWithoutProperties(pluginOptions, ["plugins", "componentName", "imagePropName", "sharpMethod"]);

    if (['fluid', 'fixed', 'resize'].indexOf(sharpMethod) < 0) reporter.panic(`'sharpMethod' only accepts 'fluid', 'fixed' or 'resize', got ${sharpMethod} instead.`);
    const targetNodes = selectAll('html, jsx', mdast);
    return Promise.all(targetNodes.map(
    /*#__PURE__*/
    function () {
      var _ref2 = _asyncToGenerator(function* (node) {
        if (!node.value) return;
        if (!node.value.includes(`<${componentName}`)) return; // locate the custom markdown syntax node

        const parsed = parse5.parseFragment(node.value);
        const customNode = parsed.childNodes.find(node => node.tagName = componentName);
        const originSrc = customNode.attrs.find(attr => attr.name === imagePropName);
        const imageRelativePath = originSrc.value;
        if (!imageRelativePath) return; // gatsby File node

        const gFileNode = getNode(markdownNode.parent);
        const imageAbsolutePath = path.resolve(gFileNode.dir, imageRelativePath); // if the image path doesn't exist, ignore

        const gImageNode = files.find(file => file.absolutePath && file.absolutePath === imageAbsolutePath);

        if (!gImageNode) {
          const fileAbsolutePath = markdownNode.fileAbsolutePath;
          reporter.error(`${fileAbsolutePath}: No image found at ${imageAbsolutePath}`);
          return;
        } // get gatsby' already built fluid image


        const args = Object.assign({
          pathPrefix,
          withWebp: false // not doing webp right now

        }, imageOptions);
        const getImage = sharp[sharpMethod];
        let imageResult = yield getImage({
          file: gImageNode,
          args,
          reporter,
          cache
        });
        if (!imageResult) return; // overwrite original src

        const src = imageResult.src,
              otherImageRes = _objectWithoutProperties(imageResult, ["src"]);

        originSrc.value = src; // add each of imageResult's value to name

        Object.keys(otherImageRes).forEach(key => {
          if (!otherImageRes[key]) return;
          customNode.attrs.push({
            name: key,
            value: otherImageRes[key].toString() // some value are numbers

          });
        }); // re-serialize the node

        node.value = parse5.serialize(parsed);
      });

      return function (_x3) {
        return _ref2.apply(this, arguments);
      };
    }()));
  });

  return function (_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();